using System;
using System.Collections.Generic;
using System.Xml;
using System.Text;
using System.Collections;

namespace XMLParser
{
    class XMLParser
    {
        /// <summary>
        /// Parses the file out puts it to the console
        /// </summary>
        /// <param name="strPath">Path to the file</param>
        public void ParseFile(string strPath)
        {
            XmlTextReader xmlReader = new XmlTextReader(strPath);
            int iTab = 0;
            // Read the line of the xml file
            while (xmlReader.Read())
            {
                switch (xmlReader.NodeType)
                {
                    case XmlNodeType.Element:
                        Hashtable attributes = new Hashtable();
                        // We add the attributes to the hash tables

                        bool isEmptyElement = false;
                        
                        PrintWhiteSpace(iTab);

                        // Print the start of the element
                        Console.Write("<" + xmlReader.Name);
                        isEmptyElement = xmlReader.IsEmptyElement;

                        if (xmlReader.HasAttributes)
                        {
                            // If element has attributes
                            for (int i = 0; i < xmlReader.AttributeCount; i++)
                            {
                                xmlReader.MoveToAttribute(i);
                                attributes.Add(xmlReader.Name, xmlReader.Value);
                                Console.Write(" " + xmlReader.Name + "=" + xmlReader.Value);
                            }
                        }

                        // Prints the end of the element
                        if (isEmptyElement == true)
                        {
                            Console.WriteLine(" />");
                        }
                        else
                        {
                            Console.WriteLine(">");
                            iTab++;
                        }                        
                        break;
                    case XmlNodeType.EndElement:
                        iTab--;
                        PrintWhiteSpace(iTab);
                        Console.WriteLine("</" + xmlReader.Name + ">");
                        break;
                    case XmlNodeType.Text:
                        PrintWhiteSpace(iTab);
                        Console.WriteLine(xmlReader.Value);
                        break;
                    default:
                        break;
                }
            }
        }

        /// <summary>
        /// Intends the output
        /// </summary>
        /// <param name="iTab">No of spaces to indent</param>
        private void PrintWhiteSpace(int iTab)
        {
            for (int i = 0; i < iTab; i++)
            {
                Console.Write(" ");
            }
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            XMLParser xml = new XMLParser();
            xml.ParseFile(@"Welcome.xml");
            Console.Read();

        }
    }
}
